import java.util.*;
import java.math.*;
import java.io.*;

class blind_as implements Runnable {
    public void solve() throws IOException {
        Scanner in = new Scanner(new File("blind.in"));
        PrintWriter out = new PrintWriter(new File("blind.out"));

        char[] c = in.next().toCharArray();
        int n = c.length;
        for (int i = 0; i < n; i++) {
            c[i] -= '0';
        }

        double[] ans = new double[n + 1];

        for (int d = 1; d <= 2 * n; d++) {
            if (d == n) {
                System.out.println("");
            }
            int[][] cnt = new int[d][2];
            int k = 0;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < d; j++) {
                    cnt[j][c[k]]++;
                    k = (k + 1) % n;
                }
            }

            int[][] nc = new int[d + 1][d + 1];
            for (int i = 0; i <= d; i++) {
                Arrays.fill(nc[i], Integer.MAX_VALUE);
            }
            nc[0][0] = 0;
            for (int i = 0; i < d; i++) {
                for (int j = 0; j <= d; j++) {
                    if (nc[i][j] < Integer.MAX_VALUE) {
                        nc[i + 1][j + 1] = Math.min(nc[i + 1][j + 1], nc[i][j] + cnt[i][1]);
                        nc[i + 1][j] = Math.min(nc[i + 1][j], nc[i][j] + cnt[i][0]);
                    }
                }
            }
            for (int j = 0; j <= d; j++) {
                if (nc[d][j] != Integer.MAX_VALUE) {
                    int x = Math.max(j, d - j);
                    if (x > n) {
                        continue;
                    }
                    double v = 1.0 - 1.0 * nc[d][j] / (n * d);
                    if (v > ans[x]) {
                        ans[x] = v;
                    }
                }
            }
        }

        for (int i = 1; i <= n; i++) {
            ans[i] = Math.max(ans[i], ans[i - 1]);
        }

        for (int i = 1; i <= n; i++) {
            out.println(ans[i]);
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
            throw new AssertionError();
        }
    }

    public static void main(String[] args) {
        new Thread(new blind_as()).start();
    }
}